<?php
// PublicSocketDataUpdater class
// (c) schmidi 2011
// www.doh-nuts.at


require_once('classes.inc.php');


class PublicSocketDataServer extends DataServer {
 	private $socket;
 	private $pass;
 	
 	private $sockets;
 	private $newsockets;
	
		
	// constructor
	function __construct($ip, $port, $pass) {
		$this->sockets = array();
		$this->newsockets = array();

		// pass pls ;)
		if (!$pass) {
			$this->socket = false;
			return;
		}
		
		if ($ip) {
			$this->socket = @socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
			if ($this->socket !== false) {
				@socket_set_nonblock($this->socket);
				@socket_bind($this->socket, $ip, $port);
				@socket_listen($this->socket);
			}
		}
		else {
			$this->socket = @socket_create_listen($port);
			if ($this->socket !== false) {
				@socket_set_nonblock($this->socket);
			}
		}
		//echo $this->socket ? "[PublicSocketDataUpdater] socket create success\n" : "[PublicSocketDataUpdater] socket create failed\n";
		
		$this->pass = $pass;
	}


	function updateData($server) {
		if (!$this->socket)
			return false;

   	// pack data
 		$bin = pack('a30a75ccccLL', $server->login, $server->name, $server->plr, $server->plr_max,
 								$server->spec, $server->spec_max, $server->ldr_min, $server->ldr_max);
 		
		// handle new connections
		foreach ($this->newsockets as $s) {
			if (@socket_recv($s, $dat, 32, 0)) {
				if ($dat == $this->pass) {
					//echo "[PublicSocketDataUpdater] auth passed\n";
					$this->sockets[] = $s;
					continue;
				}
				//echo "[PublicSocketDataUpdater] auth failed\n";
			}
			//echo "[PublicSocketDataUpdater] auth failed, nothing received\n";
			@socket_close($s);
		}
		$this->newsockets = array();
	
		// new connections
 		$i = 50;						
		while (($newsocket = @socket_accept($this->socket)) && $i-- > 0) {
			@socket_set_nonblock($newsocket);
			//echo "[PublicSocketDataUpdater] new socket\n";
			$this->newsockets[] = $newsocket;
		}

		// sending data
		$new = array();
		foreach ($this->sockets as $s) {
			if (!socket_last_error($s)) {			
				if (@socket_write($s, $bin)) {
					$new[] = $s;
					continue;
				}
			}
			@socket_close($s);
		}
		$this->sockets = $new;

    return true;
	}	

}

?>