<?php
// SocketDataUpdater class
// (c) schmidi 2011
// www.doh-nuts.at


require_once('classes.inc.php');


class SocketDataServer extends DataServer {
 	private $socket;
 	private $pass;

		
	// constructor
	function __construct($ip, $port, $pass = 'switch') {
		$this->socket = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP);
		socket_set_nonblock($this->socket);
		if (!socket_bind($this->socket, $ip, $port)) {
			$this->socket = false;
		}
		$this->pass = $pass;
	}


	function updateData($server) {
		if (!$this->socket)
			return false;

   	// pack data
 		$bin = pack('a30a75ccccLL', $server->login, $server->name, $server->plr, $server->plr_max,
 								$server->spec, $server->spec_max, $server->ldr_min, $server->ldr_max);
 		$len = strlen($bin);							
 		
   	// update clients but avoid flooding
 		$i = 50;						
 		while (@socket_recvfrom($this->socket, $buf, 128, 0, $ip, $port) > 0 && $i-- > 0) {
 			if ($buf == $this->pass) {
 				socket_sendto($this->socket, $bin, $len, 0, $ip, $port);
 			}
 		}

    return true;
	}	

}

?>